#include <tricks.h>

static byte bu_envmap[256][256];
byte bu_pal[768];

static byte  *bu_bump;
static byte  *bu_bumpmap;
static short *bu_bumpx;
static short *bu_bumpy;
static byte  *bu_text[3];

void bu_init();
void bu_loop();
void bu_newpic();

void bu_loop()
{
   static float sinus=sin(-0.05);
   static float cosin=cos(-0.05);

   static float lightx=50;
   static float lighty=50;

   float tmp=lightx*cosin+lighty*sinus;
   lighty=lighty*cosin-lightx*sinus;
   lightx=tmp;

   static int fc=0;

   fc++;
   if(fc==150){
     bu_newpic();
     fc=0;
   }

   short *srcx=bu_bumpx+321;
   short *srcy=bu_bumpy+321;
   byte *dst  =buf+321;

   int ly=lighty+27; // (-100 + 127)
   int lx=lightx-33+1; // (-160 + 127)

   int xd,yd;

   int i=197;

   do{
      int j=318;
      do
      {
         xd=*(srcx++)+(lx++);
         yd=*(srcy++)+ly;
         if((xd&0xFF00)||(yd&0xFF00))
            *dst^=*dst;
         else
            *dst=bu_envmap[yd][xd];
         dst++;
      }while(--j);
      ly++;
      lx-=318;
      dst+=2;
      srcx+=2;
      srcy+=2;
   }while(--i);
}

void bu_init()
{
   bu_bump=new byte[64000];
   bu_bumpmap=new byte[64000];
   bu_bumpx=new short[64000];
   bu_bumpy=new short[64000];
   bu_text[0]=new byte[33600];
   bu_text[1]=new byte[33600];
   bu_text[2]=new byte[33600];

   load("data\\bump.raw", bu_bump, 64000 );
   load("data\\b_coding.raw" , (byte*)bu_text[0],33600);
   load("data\\b_music.raw"  , (byte*)bu_text[1],33600);
   load("data\\b_art.raw", (byte*)bu_text[2],33600);

   for(int i=0;i<256;i++)
      for(int j=0;j<256;j++) {
         unsigned int col=256-sqrt( ((i<<1)-256)*((i<<1)-256)
                                  + ((j<<1)-256)*((j<<1)-256) );
         if(col<256)
            bu_envmap[i][j]=(byte)col;
      }

   bu_envmap[128][128] = 255;  
  
   for(i=0;i<256;i++){
     bu_pal[i*3]=0;
     bu_pal[i*3+1]=(i>>2);
     bu_pal[i*3+2]=(i>>2);
   }
   bu_newpic();
}

void bu_deinit()
{
  delete[] bu_bump;
  delete[] bu_bumpmap;
  delete[] bu_bumpx;
  delete[] bu_bumpy;

  delete[] bu_text[0];
  delete[] bu_text[1];
  delete[] bu_text[2];
}

void bu_newpic()
{
  static int picnum=0;
  fastMemCopy(bu_bump,bu_bumpmap,16000);

  byte*src = (byte*)bu_text[picnum];
  byte*dst = bu_bumpmap+40*320+20;

  for(int y=0;y<120;y++){
    for(int x=0;x<280;x++){
      int tmp=*dst+*src++;
      if(tmp>255)tmp=255;
      *dst++=tmp;
    }
    dst+=40;
  }

  src = bu_bumpmap+320;
  for(int i=0;i<63360;i++,src++){
     bu_bumpx[i]=(src[-1]-src[1])>>1;
     bu_bumpy[i]=(src[-320]-src[320])>>1;
  }   

  picnum++;
  if(picnum==3)picnum=0;
}
