int frameCount;
void cdecl prevr(void);

#include "midas.h"
#include "music.h"

static gmpModule   *module;         /* Da module */
int             error;

void initmusic( char *moduleName )
{
    static unsigned sync;            /* Screen synchronization magic */
    int         configOK;

    /* Prevent warnings: */
    int argc = 1;
    char *argv[] = {0};

    midasSetDefaults();

    midasDetectSD();
/*    if ( ((midasSDNumber != 0) && (midasSDNumber != 4)) || (argc > 1) )
        configOK = midasConfig();
    else
        configOK = 1;
*/
    if ( !configOK )
    {
       printf("Sound Config not ok!");
       exit(0);
    }

    vgaSetMode(0x03);

    if ( (error = tmrGetScrSync(&sync)) != OK )
        midasError(error);

//    printf("Sync: %d",sync);

    if ( !mSyncScreen ){
        printf("Warning! Unable to synchronize to display refresh!\n"
               "This can lead to problems in music output and flickering.\n"
               "This usually happens only when running under Windows 95 - "
               "please consider\nrunning DOS programs in DOS instead.\n"
               "Press Esc to quit or any other key to continue\n");
        if ( getch() == 27 )
        {
            printf("Quit due to escape pressed!");
            exit(0);
        }
    }

    midasInit();

    /* Debug stuff: */
    printf("Using %s\n%s, using port %X, IRQ %i and DMA %i\n",
        midasSD->name, midasSD->cardNames[midasSD->cardType-1],
        midasSD->port, midasSD->IRQ, midasSD->DMA);

    puts("Loading music");

    /* Load the module: (Not too hard to change for PT or ST3 modules ;) */
    if ( (error = gmpLoadXM(moduleName, 1, NULL, &module)) != OK )
        midasError(error);
    /* Hint: Think of the file name extensions... */

    /* Now we could do all our initialization, set up a fancy display mode
       etc. */

    /* Synchronize the timer to screen update and call prevr() just before
       each Vertical Retrace: */
    if ( (error = tmrSyncScr(sync, &prevr, NULL, NULL)) != OK )
        midasError(error);

    /* Start playing the module: */
    midasPlayModule(module, 0);

    /* Set the music synchronization callback function: */
    if ( (error = gmpSetSyncCallback(midasPlayHandle, &SyncCallback)) != OK )
        midasError(error);
}

void stopmusic()
{
    /* Stop playing module: */
    midasStopModule(module);

    /* Deallocate the module: */
    if ( (error = gmpFreeModule(module)) != OK )
        midasError(error);

    /* And close MIDAS: */
    midasClose();
}

