#include <tricks.h>
#include <xreader.h>

// GLOBALS ************************************************************

#define SCRWID 320

static int  zbuf[SCRWID*200];
//static obj  *O;
static obj  *O2;
static byte envmap[65536];
static byte pz_pal[768];
//static int  *df;
static int  zadd;

// PROTOTYPES *******************************************************

void pz_drawObj(byte *dest);
void pz_init();
void pz_deinit();
void pz_loop();

// CODE *****************************************************************



inline void drawTxtZ(int &xA,int &xB,int uA,int vA,int zA,
                     int &uB,int &vB,int &zB,byte *b,int *z)
{
  int width,du,dv,dz;

  width=xB-xA;
  du=(uB-uA)/width;
  dv=(vB-vA)/width;
  dz=(zB-zA)/width;

  do{
    if(*z>zA){
      *z=zA;
      *b=envmap[(uA>>8)+(vA&0xff00)];
    }
    b++;
    z++;
    uA+=du;
    vA+=dv;
    zA+=dz;
  }while(width--);
}

void pz_loop()
{
    rotate(O,0.01,0.01,0.02,2,600);
    rotate(O2,-0.01,0.03,0.015,2,600);
    pz_drawObj(buf);
    swap(O,O2);
    pz_drawObj(buf);
    swap(O,O2);
    zadd+=60000;
    if(zadd>2000000000){          // 2 billions.. oughta be enough.. :)
      zadd=0;
      fastMemClear((byte*)zbuf,64000);
    }
}

void pz_drawObj(byte *dest)
{
  int count=0;              // number of faces..

  for(int i=0;i<O->faces;i++) {
    if(O->f[i].zn>0)
      df[count++] = i;
  }

  i=count;

  do{
    int p1=O->f[*df].p1;
    int p2=O->f[*df].p2;
    int p3=O->f[*df].p3;

    int p1y=O->v[p1].py;
    int p2y=O->v[p2].py;
    int p3y=O->v[p3].py;

    if(p1y>p2y) {
      swap(p1y,p2y);
      swap(p1 ,p2);
    }

    if(p1y>p3y) {
      swap(p1y,p3y);
      swap(p1 ,p3);
    }

    int dyA=p2y-p1y;
    int dyB=p3y-p1y;

    int xA,xB;
    int uA,uB;
    int vA,vB;
    int zA,zB;

    xA=xB  =O->v[p1].px;                         // px<<8 done..
    uA=uB  =QuickFist(O->v[p1].xn*30720)+32512;  // 32512 = 127<<8;
    vA=vB  =QuickFist(O->v[p1].yn*30720)+32512;  // 30720 = 120<<8;
    zA=zB  =QuickFist(O->v[p1].z*40000)-zadd;

    int p2x=O->v[p2].px;
    int p2u=QuickFist(O->v[p2].xn*30720)+32512;
    int p2v=QuickFist(O->v[p2].yn*30720)+32512;
    int p2z=QuickFist(O->v[p2].z*40000)-zadd;

    int p3x=O->v[p3].px;
    int p3u=QuickFist(O->v[p3].xn*30720)+32512;
    int p3v=QuickFist(O->v[p3].yn*30720)+32512;
    int p3z=QuickFist(O->v[p3].z*40000)-zadd;

    int dxA,duA,dvA,dzA;
    int dxB,duB,dvB,dzB;

    if(dyA){
      dxA=(p2x-xA)/dyA;
      duA=(p2u-uA)/dyA;
      dvA=(p2v-vA)/dyA;
      dzA=(p2z-zA)/dyA;
    }else{
      dyA++;
      dxA=(p2x-xA);
      duA=(p2u-uA);
      dvA=(p2v-vA);
      dzA=(p2z-zA);
    }

    if(dyB){
      dxB=(p3x-xA)/dyB;
      duB=(p3u-uA)/dyB;
      dvB=(p3v-vA)/dyB;
      dzB=(p3z-zA)/dyB;
    }else{
      dyB++;
      dxB=(p3x-xA);
      duB=(p3u-uA);
      dvB=(p3v-vA);
      dzB=(p3z-zA);
    }

    byte *b=dest+p1y*SCRWID;
    int  *z=zbuf+p1y*SCRWID;

    do{
      int xAs=xA>>8;
      int xBs=xB>>8;

      if(xBs>xAs)      drawTxtZ(xAs,xBs,uA,vA,zA,uB,vB,zB,b+xAs,z+xAs);
      else if(xBs<xAs) drawTxtZ(xBs,xAs,uB,vB,zB,uA,vA,zA,b+xBs,z+xBs);

      dyA--;
      dyB--;
      if(dyA<0&&dyB<0) break;

      xA+=dxA;
      uA+=duA;
      vA+=dvA;
      zA+=dzA;

      xB+=dxB;
      uB+=duB;
      vB+=dvB;
      zB+=dzB;

      if(!dyA){
        dyA=p3y-p2y;
        if(dyA){
          dxA=(p3x-p2x)/dyA;
          duA=(p3u-p2u)/dyA;
          dvA=(p3v-p2v)/dyA;
          dzA=(p3z-p2z)/dyA;
        }else{
          dxA=(p3x-p2x);
          duA=(p3u-p2u);
          dvA=(p3v-p2v);
          dzA=(p3z-p2z);
        }
      }else if(!dyB){
        dyB=p2y-p3y;
        if(dyB){
          dxB=(p2x-p3x)/dyB;
          duB=(p2u-p3u)/dyB;
          dvB=(p2v-p3v)/dyB;
          dzB=(p2z-p3z)/dyB;
        }else{
          dxB=(p2x-p3x);
          duB=(p2u-p3u);
          dvB=(p2v-p3v);
          dzB=(p2z-p3z);
        }
      }
      b+=SCRWID;
      z+=SCRWID;
    }while(dyA>=0&&dyB>=0);
    df++;
  }while(--i);
  df-=count;
}

void pz_init()
{
   O=new obj;
   readobj(O,"data\\blob.x");
   O2=new obj;
   readobj(O2,"data\\blob.x");
   df=new int[O->faces];    
   loadmap("data\\colblob",envmap,pz_pal);
   for(int i=0;i<256;i++)
      Pal(i,pz_pal[i*3],pz_pal[i*3+1],pz_pal[i*3+2]);
}

void pz_deinit()
{
   delete[] O->v;
   delete[] O->f;
   delete O;
}

