#include "tricks.h"
#include <stdio.h>

byte buffer[64000];
byte txtmap[4096];

byte palette[256][3];

int costab[1280];
int sintab[1280];
int y_tab[200];

void load();
void rotimage( int rotspeed, int skalspeed );

void main()
{
   load();
  
   GrabPallette();
   SetMCGA();

   for( int i=0; i<256; i++)
      Pal(i,palette[i][0],palette[i][1],palette[i][2]);

   for( i=0; i<1280; i++)      
      costab[i] = (int) (cos( ((float) i) * 2 * PI /1024 )*256);

   for( i=0; i<1280; i++)      
      sintab[i] = (int) (sin( ((float) i) * 2 * PI /1024 )*65536);

   for( i=0; i<200; i++)      
      y_tab[i] = i*320;


   do
   {
      Pal(0,30,0,0);
      rotimage(6,2);
      Pal(0,0,0,0);
      WaitRetrace();
      Pal(0,0,30,0);
      fastMemCopy(buf,vga,16000);

   } while (!kbhit());

   getch();
   SetText();
   RestorePallette();
}

void tw_init()
{
   for( int i=0; i<256; i++)
      Pal(i,palette[i][0],palette[i][1],palette[i][2]);

   for( i=0; i<1280; i++)      
      costab[i] = (int) (cos( ((float) i) * 2 * PI /1024 )*256);

   for( i=0; i<1280; i++)      
      sintab[i] = (int) (sin( ((float) i) * 2 * PI /1024 )*65536);

   for( i=0; i<200; i++)      
      y_tab[i] = i*320;
}

void rotimage( int rotspeed, int skalspeed )
{
   static int rot = 512;
   static int skal = 0;

   int scale, sinus, cosin;

   skal += skalspeed;
   rot  += rotspeed;

   skal &= 1023;
   rot  &= 1023;

   scale = sintab[skal];
   sinus = sintab[rot] + scale;
   cosin = sintab[rot+256] + scale;

   byte *temp = buf;

   for(int y=-100; y<100; y++)
   {
      long siny= ((sinus*y) >> 16 )+160;
      long cosy= ((cosin*y) >> 16 )-100;

      for(int x=-160; x<160; x++)
      {
         unsigned int xt = ((( cosin*x ) >> 16 ) + siny)&63;
         unsigned int yt = ((( sinus*x ) >> 16 ) - cosy)&63;

         *temp++ = txtmap[ xt+(yt<<6)];
      }
	}
}


void load()
{
   FILE *fp = fopen( "..\\data\\fz-text.raw", "rb" );

   fread( txtmap, 4096, 1, fp);
   fclose( fp );

   fp = fopen( "..\\data\\frozty.pal", "r" );

   for( int i=0; i<256; i++)
   {
      int r,g,b;

      fscanf( fp, "%d %d %d", &r,&g,&b);

      palette[i][0] = r>>2;
      palette[i][1] = g>>2;
      palette[i][2] = b>>2;
   }

   fclose( fp );
}
