#include <tricks.h>
#include <mod.h>
#include <xreader.h>
#include "readspl.h"

byte buf[64000];
obj *O;
int *df;
byte pal[768];
int i;

#include "intro.cpp"
#include "bitaddic.cpp"
#include "wormzbig.cpp"
#include "bumpmap.cpp"
#include "plasma.cpp"
#include "phongz.cpp"
#include "picshow.cpp"

void setblack();
void setwhite();
void fadetowhite();
void fadetoblack();
void fadefromwhite(byte *pal);
void fadefromblack(byte *pal);
void setpal(byte*pal);

int nocount=0;

void cdecl prevr(void)
{
    if(!nocount)
      frameCount++;

    if(kbhit())
      frameCount=1000000;

    if(frameCount>3){
      if(frameCount<70)
        fadefromblack(ba_pal);
      else if(frameCount>430&&frameCount<500)
        fadetoblack();
    }

}

void main()
{
  nocount=1;
  initmusic("data\\morpheus.xm");
  SetText();
  printf("Precalcing.. pliz w8.. \n\n");
//  in_init();
  wb_precalc();             // calculate wormhole
//  in_deinit();             

  SetMCGA();
  ba_init();
  setblack();
  nocount=0;
  do{
      ba_loop();
      WaitRetrace();
      fastMemCopy(buf,vga,16000);
  }while(frameCount<500);

  setblack();

  init("data\\blob2.x","data\\envmap","data\\spline3.spl");
  loop();
  deinit();

  setblack();
  wb_init();
  setpal(wb_pal);

  i=1100;
  do{
      wb_loop();
      WaitRetrace();
      fastMemCopy(buf,vga,16000);
  }while(--i);
    fastMemClear(buf,16000);

  setblack();
  wb_deinit();
  fastMemClear(buf,16000);
  bu_init();
  setpal(bu_pal);

  i=900;
  do{
     bu_loop();
     WaitRetrace();
     fastMemCopy(buf,vga,16000);
  }while(--i);
    fastMemClear(buf,16000);

  setblack();
  bu_deinit();
  init("data\\spikboll.x","data\\flare","data\\spline4.spl");
  loop();
  deinit();
  pl_init();
  setpal(pal);

  i=500;
  do{
     pl_loop();  
     WaitRetrace();
     fastMemCopy(buf,vga,16000);
  }while(--i);
  fastMemClear(buf,16000);

  init("data\\nd.x","data\\colblob","data\\spline1.spl");
  loop();
  deinit();

  i=1000;
  pz_init();
  do{
    pz_loop();
    fastMemCopy(buf,vga,16000);
    fastMemClear(buf,16000);
  }while(--i);
  pz_deinit();

  i=60;
  showdragon();
  do{
    WaitRetrace();
  }while(--i);

  init("data\\boll.x","data\\fractal","data\\spline2.spl");
  loop();
  deinit();

  stopmusic();
  SetText();

  printf("Thank you for watching Bit Addict by Neural Debris!\n\n");
  printf("Released at DreamHack '97, Borlnge, Sweden\n\n");
  printf("Code & 3D - Thoughtie & Mozel\n");
  printf("Music     - Spasm\n");
  printf("Artwork   - Accipiter\n");
}

void fadetowhite()
{
  for(int i=0;i<256;i++){
    byte r,g,b;
    GetPal(i,r,g,b);
    if(r<63)r++;
    if(g<63)g++;
    if(b<63)b++;
    Pal(i,r,g,b);
  }
}

void fadetoblack()
{
  for(int i=0;i<256;i++){
    byte r,g,b;
    GetPal(i,r,g,b);
    if(r)r--;
    if(g)g--;
    if(b)b--;
    Pal(i,r,g,b);
  }
}

void fadefromblack(byte *pal)
{
  for(int i=0;i<256;i++){
    byte r,g,b;
    GetPal(i,r,g,b);
    if(r<pal[i*3])r++;
    if(g<pal[i*3+1])g++;
    if(b<pal[i*3+2])b++;
    Pal(i,r,g,b);
  }
}

void fadefromwhite(byte *pal)
{
  for(int i=0;i<256;i++){
    byte r,g,b;
    GetPal(i,r,g,b);
    if(r>pal[i*3])r--;
    if(g>pal[i*3+1])g--;
    if(b>pal[i*3+2])b--;
    Pal(i,r,g,b);
  }
}

void setwhite()
{
  for(int i=0;i<256;i++)
    Pal(i,63,63,63);
}

void setblack()
{
  for(int i=0;i<256;i++)
    Pal(i,0,0,0);
}

void setpal(byte*pal)
{
  for(int i=0;i<256;i++)
    Pal(i,pal[i*3],pal[i*3+1],pal[i*3+2]);
}
